#-*- coding:utf-8 -*-

#  Copyright (C) 2009 B. Clausius
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Ported from GNUbik
# Original filename: debug.scm
# Original copyright and license:
#;;   Copyright (c) 2004 Dale Mellor
#;;
#;;   This program is free software; you can redistribute it and/or modify
#;;   it under the terms of the GNU General Public License as published by
#;;   the Free Software Foundation; either version 3 of the License, or
#;;   (at your option) any later version.
#;;
#;;   This program is distributed in the hope that it will be useful,
#;;   but WITHOUT ANY WARRANTY; without even the implied warranty of
#;;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;;   GNU General Public License for more details.
#;;
#;;   You should have received a copy of the GNU General Public License
#;;   along with this program.  If not, see <http://www.gnu.org/licenses/>.


def dump_state():
    cube = (plugin_cube_state)
    display 
    'Cube geometry (version dimensionality size-of-dim-1 ...): '
    newline
    display 
    '          '
    display 
    car(cube)
    newline
    array_for_each
     
    def lambda_((a)):
        array_for_each
        
        def lambda_((b)):
            display 
            b
            display 
            ' '
        
        a
        newline
     
    cdr(cube)
    newline


def debug_move_animated (face):
    cube = (plugin_cube_state)
    if (check_cube_structure, cube):
        begin
          
        clear_move_buffer_p
          
        move_face 
        cube 
        face
          
        execute_move_buffer_p


debug_scripts = [
    ('Debug/Dump state', dump_state),
    ('Debug/Move/F',     lambda: debug_move_animated("f")),
    ('Debug/Move/B',     lambda: debug_move_animated("b")),
    ('Debug/Move/L',     lambda: debug_move_animated("l")),
    ('Debug/Move/R',     lambda: debug_move_animated("r")),
    ('Debug/Move/U',     lambda: debug_move_animated("u")),
    ('Debug/Move/D',     lambda: debug_move_animated("d")),
]

